Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkAmoebaMinimizer Class Reference

`#include <vtkAmoebaMinimizer.h>`

Inheritance diagram for vtkAmoebaMinimizer:

[legend]
Collaboration diagram for vtkAmoebaMinimizer:

[legend]
List of all members.

## Detailed Description

nonlinear optimization with a simplex

Date:
  2002/11/12 19:07:11

Revision:
  1.3

vtkAmoebaMinimizer will modify a set of parameters in order to find the minimum of a specified function. The method used is commonly known as the amoeba method, it constructs an n-dimensional simplex in parameter space (i.e. a tetrahedron if the number or parameters is 3) and moves the vertices around parameter space until a local minimum is found. The amoeba method is robust, reasonably efficient, but is not guaranteed to find the global minimum if several local minima exist.

Created by:
  - Gobbi, David

CVS contributions (if > 5%):
  - Gobbi, David (98%)

CVS logs (CVSweb):
  - .`h` (`/Common/vtkAmoebaMinimizer.h)`
  - .`cxx` (`/Common/vtkAmoebaMinimizer.cxx)`

Tests:
  vtkAmoebaMinimizer (Tests)

Definition at line 50 of file vtkAmoebaMinimizer.h.

## Public Types
typedef vtkObject | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
void | SetFunction (void(*f)(void *), void *arg)
void | SetFunctionArgDelete (void(*f)(void *))
const char * | GetParameterName (int i)
int | GetNumberOfParameters ()
void | Initialize ()
virtual void | Minimize ()
virtual int | Iterate ()
void | EvaluateFunction ()
void | SetParameterValue (const char *name, double value)
void | SetParameterValue (int i, double value)
void | SetParameterScale (const char *name, double scale)
double | GetParameterScale (const char *name)
void | SetParameterScale (int i, double scale)
double | GetParameterScale (int i)
double | GetParameterValue (const char *name)
double | GetParameterValue (int i)
virtual void | SetFunctionValue (double)
double | GetFunctionValue ()
virtual void | SetTolerance (double)
virtual double | GetTolerance ()
virtual void | SetMaxIterations (int)
virtual int | GetMaxIterations ()
virtual int | GetIterations ()
virtual int | GetFunctionEvaluations ()
## Static Public Methods
vtkAmoebaMinimizer * | New ()
int | IsTypeOf (const char *type)
vtkAmoebaMinimizer * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkAmoebaMinimizer ()
| ~vtkAmoebaMinimizer ()
## Protected Attributes
void(* | Function )(void *)
void(* | FunctionArgDelete )(void *)
void * | FunctionArg
int | NumberOfParameters
char ** | ParameterNames
double * | ParameterValues
double * | ParameterScales
double | FunctionValue
double | Tolerance
int | MaxIterations
int | Iterations
int | FunctionEvaluations

## Member Typedef Documentation

typedef vtkObject vtkAmoebaMinimizer::Superclass

| Reimplemented from vtkObject. Definition at line 54 of file vtkAmoebaMinimizer.h.

## Constructor & Destructor Documentation

vtkAmoebaMinimizer::vtkAmoebaMinimizer | ( |  | ) | `[protected]`

vtkAmoebaMinimizer::~vtkAmoebaMinimizer | ( |  | ) | `[protected]`

## Member Function Documentation

vtkAmoebaMinimizer* vtkAmoebaMinimizer::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkObject.

virtual const char* vtkAmoebaMinimizer::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkObject.

int vtkAmoebaMinimizer::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkObject.

virtual int vtkAmoebaMinimizer::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkObject.

vtkAmoebaMinimizer* vtkAmoebaMinimizer::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkObject.

void vtkAmoebaMinimizer::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkObject.

void vtkAmoebaMinimizer::SetFunction | ( | void(* | f)(void *),
|  | void * | arg
| ) |

| Specify the function to be minimized. When this function is called, it must get the parameter values by calling GetParameterValue() for each parameter, and then must call SetFunctionValue() to tell the minimizer what the result of the function evaluation was. The number of function evaluations used for the minimization can be retrieved using GetFunctionEvaluations().

void vtkAmoebaMinimizer::SetFunctionArgDelete | ( | void(* | f)(void *) | ) |

| Set a function to call when a void* argument is being discarded.

void vtkAmoebaMinimizer::SetParameterValue | ( | const char * | name,
|  | double | value
| ) |

| Set the initial value for the specified parameter. Calling this function for any parameter will reset the Iterations and the FunctionEvaluations counts to zero. You must also use SetParameterScale() to specify the step size by which the parameter will be modified during the minimization. It is preferable to specify parameters by name, rather than by number.

void vtkAmoebaMinimizer::SetParameterValue | ( | int | i,
|  | double | value
| ) |

| Set the initial value for the specified parameter. Calling this function for any parameter will reset the Iterations and the FunctionEvaluations counts to zero. You must also use SetParameterScale() to specify the step size by which the parameter will be modified during the minimization. It is preferable to specify parameters by name, rather than by number.

void vtkAmoebaMinimizer::SetParameterScale | ( | const char * | name,
|  | double | scale
| ) |

| Set the scale to use when modifying a parameter, i.e. the initial amount by which the parameter will be modified during the search for the minimum. It is preferable to identify scalars by name rather than by number.

double vtkAmoebaMinimizer::GetParameterScale | ( | const char * | name | ) |

| Set the scale to use when modifying a parameter, i.e. the initial amount by which the parameter will be modified during the search for the minimum. It is preferable to identify scalars by name rather than by number.

void vtkAmoebaMinimizer::SetParameterScale | ( | int | i,
|  | double | scale
| ) |

| Set the scale to use when modifying a parameter, i.e. the initial amount by which the parameter will be modified during the search for the minimum. It is preferable to identify scalars by name rather than by number.

double vtkAmoebaMinimizer::GetParameterScale | ( | int | i | ) | `[inline]`

| Set the scale to use when modifying a parameter, i.e. the initial amount by which the parameter will be modified during the search for the minimum. It is preferable to identify scalars by name rather than by number. Definition at line 87 of file vtkAmoebaMinimizer.h.

double vtkAmoebaMinimizer::GetParameterValue | ( | const char * | name | ) |

| Get the value of a parameter at the current stage of the minimization. Call this method within the function that you are minimizing in order to get the current parameter values. It is preferable to specify parameters by name rather than by index.

double vtkAmoebaMinimizer::GetParameterValue | ( | int | i | ) | `[inline]`

| Get the value of a parameter at the current stage of the minimization. Call this method within the function that you are minimizing in order to get the current parameter values. It is preferable to specify parameters by name rather than by index. Definition at line 96 of file vtkAmoebaMinimizer.h.

const char* vtkAmoebaMinimizer::GetParameterName | ( | int | i | ) | `[inline]`

| For completeness, an unchecked method to get the name for particular parameter (the result will be NULL if no name was set). Definition at line 101 of file vtkAmoebaMinimizer.h.

int vtkAmoebaMinimizer::GetNumberOfParameters | ( |  | ) | `[inline]`

| Get the number of parameters that have been set. Definition at line 104 of file vtkAmoebaMinimizer.h.

void vtkAmoebaMinimizer::Initialize | ( |  | ) |

| Initialize the minimizer. This will reset the number of parameters to zero so that the minimizer can be reused.

virtual void vtkAmoebaMinimizer::Minimize | ( |  | ) | `[virtual]`

| Iterate until the minimum is found to within the specified tolerance, or until the MaxIterations has been reached.

virtual int vtkAmoebaMinimizer::Iterate | ( |  | ) | `[virtual]`

| Perform one iteration of minimization. Returns zero if the tolerance stopping criterion has been met.

virtual void vtkAmoebaMinimizer::SetFunctionValue | ( | double |  | ) | `[virtual]`

| Get the function value resulting from the minimization.

double vtkAmoebaMinimizer::GetFunctionValue | ( |  | ) | `[inline]`

| Get the function value resulting from the minimization. Definition at line 121 of file vtkAmoebaMinimizer.h.

virtual void vtkAmoebaMinimizer::SetTolerance | ( | double |  | ) | `[virtual]`

| Specify the fractional tolerance to aim for during the minimization.

virtual double vtkAmoebaMinimizer::GetTolerance | ( |  | ) | `[virtual]`

| Specify the fractional tolerance to aim for during the minimization.

virtual void vtkAmoebaMinimizer::SetMaxIterations | ( | int |  | ) | `[virtual]`

| Specify the maximum number of iterations to try before giving up.

virtual int vtkAmoebaMinimizer::GetMaxIterations | ( |  | ) | `[virtual]`

| Specify the maximum number of iterations to try before giving up.

virtual int vtkAmoebaMinimizer::GetIterations | ( |  | ) | `[virtual]`

| Return the number of interations that have been performed. This is not necessarily the same as the number of function evaluations.

virtual int vtkAmoebaMinimizer::GetFunctionEvaluations | ( |  | ) | `[virtual]`

| Return the number of times that the function has been evaluated.

void vtkAmoebaMinimizer::EvaluateFunction | ( |  | ) |

| Evaluate the function. This is usually called internally by the minimization code, but it is provided here as a public method.

## Member Data Documentation

void(* vtkAmoebaMinimizer::Function)(void *)`[protected]`

void(* vtkAmoebaMinimizer::FunctionArgDelete)(void *)`[protected]`

void* vtkAmoebaMinimizer::FunctionArg`[protected]`

| Definition at line 158 of file vtkAmoebaMinimizer.h.

int vtkAmoebaMinimizer::NumberOfParameters`[protected]`

| Definition at line 161 of file vtkAmoebaMinimizer.h.

char** vtkAmoebaMinimizer::ParameterNames`[protected]`

| Definition at line 162 of file vtkAmoebaMinimizer.h.

double* vtkAmoebaMinimizer::ParameterValues`[protected]`

| Definition at line 163 of file vtkAmoebaMinimizer.h.

double* vtkAmoebaMinimizer::ParameterScales`[protected]`

| Definition at line 164 of file vtkAmoebaMinimizer.h.

double vtkAmoebaMinimizer::FunctionValue`[protected]`

| Definition at line 165 of file vtkAmoebaMinimizer.h.

double vtkAmoebaMinimizer::Tolerance`[protected]`

| Definition at line 167 of file vtkAmoebaMinimizer.h.

int vtkAmoebaMinimizer::MaxIterations`[protected]`

| Definition at line 168 of file vtkAmoebaMinimizer.h.

int vtkAmoebaMinimizer::Iterations`[protected]`

| Definition at line 169 of file vtkAmoebaMinimizer.h.

int vtkAmoebaMinimizer::FunctionEvaluations`[protected]`

| Definition at line 170 of file vtkAmoebaMinimizer.h.

The documentation for this class was generated from the following file:

- Common/vtkAmoebaMinimizer.h